#include "picoled.h"

#include <cstdlib>

namespace
{

picoled::pixel DUMMY_PIXEL;

}

namespace picoled
{

oled::oled(size_t width, size_t height) :
  pixels(new pixel[width * height]),
  width(width),
  height(height)
{}

oled::~oled()
{
  delete[] pixels;
}


pixel& oled::operator()(int x, int y)
{
  if (x < 0 || x >= width || y < 0 || y >= height) { return DUMMY_PIXEL; }
  return pixels[x + y * width];
}

const pixel& oled::operator()(int x, int y) const
{
  if (x < 0 || x >= width || y < 0 || y >= height) { return DUMMY_PIXEL; }
  return pixels[x + y * width];
}

void oled::update() const
{
  update_impl();
}

bool oled::is_on(int x, int y) const
{
  return (*this)(x, y).value > rand() % 0xFF;
}

void oled::clear()
{
  for (int i = 0; i < width * height; i++)
  {
    pixels[i] = false;
  }
}

}
